#include <windows.h>
#include <stdio.h>
#include "main.h"
#include "RemoteThread.h"
#include "win9x.h"

int main(int argc,char **argv)
{

	printf("\nExecute code in the address space of a other process on WinNT and Win9x\n");
	printf("This is a demo program to show you how it works\n");
	printf("Refer any questions to michel000@planet.nl\n");
	printf("Copyright (C) 2004  Michel van Kerkhof\n\n");

	if (argc < 3 || 
		(strcmp(argv[1],"-dll") && strcmp(argv[1],"-m")) ||
		(strcmp(argv[1],"-dll") == 0 && argc < 4)
	) {
		char *pThisFile;
		pThisFile=strrchr(argv[0],'\\');

		if (pThisFile) pThisFile++;
		else pThisFile="RemoteThread.exe";

		//Show usage
		printf("To load a dll in a other program please type:\n");
		printf("%s -dll [name of the program] [name of the dll to load]\n\n",pThisFile);
		printf("To create a messagebox in a other program please type:\n");
		printf("%s -m [name of the program]\n\n",pThisFile);
		return 0;
	}

	//Execute target process

	PROCESS_INFORMATION	ProcInfo;
	STARTUPINFO			StartInfo;
	
	memset(&StartInfo,0,sizeof(StartInfo));
	StartInfo.cb=sizeof(STARTUPINFO);

	if (CreateProcess(NULL,
					argv[2],
					NULL,
					NULL,
					FALSE,
					0,
					NULL,
					NULL,
					&StartInfo,
					&ProcInfo) == 0) {
		printf("Could not execute process\n");
		return 0;
	}

	/*
		Waith for the process to startup if you dont do this you have a big change the process
		will crash
		This works only for GUI programs so if the function fails Sleep for 5 secs. to give it some time
	*/

	if (WaitForInputIdle(ProcInfo.hProcess,10000) != 0) Sleep(5000);

	Sleep(1000);

	if (strcmp(argv[1],"-m") == 0) {
		RemoteMessageBox(ProcInfo.hProcess,ProcInfo.hThread,ProcInfo.dwThreadId);
	}
	else if (strcmp(argv[1],"-dll") == 0) {
		RemoteLoadLibrary(ProcInfo.hProcess,ProcInfo.hThread,ProcInfo.dwThreadId,argv[3]);
	}
	
	return 0;
}


/*
	Code to copy to remote process for creating a messagebox
*/

DWORD WINAPI ExampleThread(INJECTDATA *pData)
{
	pMessageBox fMessageBox;
	fMessageBox = (pMessageBox)pData->fGetProcAddress(pData->fLoadLibraryA(pData->szUser32),pData->szMessageBoxA);
	if (fMessageBox) return fMessageBox(NULL,pData->szText,pData->szTitle,MB_ICONINFORMATION | MB_YESNOCANCEL);
	return 0;
}


/*
	This function creates a messagebox in a other process
*/

int RemoteMessageBox(HANDLE hProcess,HANDLE hThread,DWORD dwThreadId)
{
	LPVOID lpRemThread,lpRemData;

	/*
		Create memory in the remote process to copy code for the thread to
		i use 100 for the size but it should be the size of the thread 
		but more isnt a problem 
	*/

	lpRemThread=xVirtualAllocEx(hProcess,100);

	/*
		Create memory in the remote process to copy parameter for the thread to
	*/

	lpRemData=xVirtualAllocEx(hProcess,sizeof(INJECTDATA));

	if (!lpRemThread || !lpRemData) {
#ifdef DEBUG
		DisplayError(NULL);
		printf("Error creating memory in the remote process\n");
#endif
		return 0;
	}

	/*
		Write code to remote memory
	*/

	if (!xWriteProcessMemory(hProcess,lpRemThread,ExampleThread,100)) {
		printf("Error writing data to remote process\n");
		xVirtualFreeEx(hProcess,lpRemThread);
		xVirtualFreeEx(hProcess,lpRemData);
		return 0;
	}

	/*
		Fill INJECTDATA struct 
	*/

	INJECTDATA iData;

	iData.fLoadLibraryA=(pLoadLibraryA)GetProcAddress(GetModuleHandle("kernel32"),"LoadLibraryA");
	iData.fGetProcAddress=(pGetProcAddress)GetProcAddress(GetModuleHandle("kernel32"),"GetProcAddress");
	strcpy(iData.szUser32,"user32");
	strcpy(iData.szMessageBoxA,"MessageBoxA");
	strcpy(iData.szText,"This is a MessageBox Executed in a other process");
	strcpy(iData.szTitle,"RemoteThread By Michel");

	/*
		Write INJECTDATA struct to the remote process
	*/

	if (!xWriteProcessMemory(hProcess,lpRemData,&iData,sizeof(INJECTDATA))) {
		printf("Error writing data to remote process\n");
		xVirtualFreeEx(hProcess,lpRemThread);
		xVirtualFreeEx(hProcess,lpRemData);
		return 0;
	}

	/*
		Create the remote thread
	*/

	HANDLE hNewThread;
	DWORD dwNewThreadId;

	hNewThread = xCreateRemoteThread(
		hThread,
		hProcess,
		dwThreadId,
		(LPTHREAD_START_ROUTINE)lpRemThread,
		lpRemData,
		&dwNewThreadId
	);


	if (hNewThread == NULL) {
		printf("Error creating remote thread\n");
		xVirtualFreeEx(hProcess,lpRemThread);
		xVirtualFreeEx(hProcess,lpRemData);
		return 0;
	}
	
	printf("\nThread id of the remote thread is:%i\n",dwNewThreadId);


	/*
		Wait for the remote thread to finish
	*/

	WaitForSingleObject(hNewThread, INFINITE);

	/*
		Get Exit code of the remote thread
	*/

	DWORD dwExit;

	if (GetExitCodeThread(hNewThread,&dwExit)) {
		printf("ExitCode of the remote thread is:%i\n\n",dwExit);
	}
	else {
		printf("Could not get exit code of remote thread\n");
	}

	/*
		Close handle to the thread and free memory
	*/

	CloseHandle(hNewThread);

	xVirtualFreeEx(hProcess,lpRemThread);
	xVirtualFreeEx(hProcess,lpRemData);

	return 0;
}

/*
	Function loads a dll into a other process

	Note: We don't copy any code the the remote process
	as starting point for the remote thread we just use LoadLibrary
	and we only copy the name of the dll to the process
*/

int RemoteLoadLibrary(HANDLE hProcess,HANDLE hThread,DWORD dwThreadId,char *szDllName)
{
	LPVOID lpRemData;

	/*
		Create memory in the remote process to copy parameter for the thread to
	*/

	lpRemData=xVirtualAllocEx(hProcess,strlen(szDllName));

	if (!lpRemData) {
		printf("Error creating memory in the remote process\n");
		return 0;
	}

	/*
		Copy name of the dll to the remote process
	*/

	if (!xWriteProcessMemory(hProcess,lpRemData,szDllName,strlen(szDllName))) {
		printf("Error writing data to remote process\n");
		xVirtualFreeEx(hProcess,lpRemData);
		return 0;
	}

	/*
		Create the remote thread
	*/

	HANDLE hNewThread;
	DWORD dwNewThreadId;

	hNewThread = xCreateRemoteThread(
		hThread,
		hProcess,
		dwThreadId,
		(LPTHREAD_START_ROUTINE)GetProcAddress(GetModuleHandle("kernel32"),"LoadLibraryA"), //Start address is LoadLibrary
		lpRemData,
		&dwNewThreadId
	);

	if (hNewThread == NULL) {
		printf("Error creating remote thread\n");
		xVirtualFreeEx(hProcess,lpRemData);
		return 0;
	}
	
	printf("\nThread id of the remote thread is:%i\n",dwNewThreadId);

	/*
		Wait for the remote thread to finish
	*/

	WaitForSingleObject(hNewThread, INFINITE);

	/*
		Get Exit code of the remote thread
	*/

	DWORD dwExit;
	if (GetExitCodeThread(hNewThread,&dwExit)) {
		printf("ExitCode of the remote thread is:%i\n\n",dwExit);

		if (dwExit == NULL) printf("Error Loading dll in the remote process\n");
		else printf("Dll Loaded succesfully handle of the dll: %0.8x\n",dwExit);
	}
	else {
		printf("Could not get exit code of the thread\n");
	}

	/*
		Free memory and close handle to the thread
	*/

	CloseHandle(hNewThread);
	
	xVirtualFreeEx(hProcess,lpRemData);

	return 0;
}

