//////////////////////////////////////////////////////////////////////////////
//  File:       insider.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <tlhelp32.h>
#include <psapi.h>
#include <pcre.h>
#include "detours.h"
#pragma warning(disable:4100)   // Trampolines don't use formal parameters.
#include "intercept-trampoline_def.h"
#include "config.h"

//NOTE: STRMAXLEN means the max length of string. 
//So we need extra space of one char to store the ending NULL char
char g_sMainModuleFileName[FILENAME_STRMAXLEN+1] = ""; //g_sMainModuleFileName: file name of main module(often EXE files); path is included.
char g_sInsiderFolder[FILENAME_STRMAXLEN+1] = ""; //g_sInsiderFolder: folder name of INSIDER.dll; path is included; no ending slash.
char g_sCurrentUserName[USERNAME_STRMAXLEN+1] = "";// g_sUserName: Username of current login
pcre * g_ListedCompiledRegex[PATTERN_MAXNUM]; //g_ListedCompiledRegex: store compiled regex patterns which are listed in "WBLIST.TXT"
DWORD g_ListedActions[PATTERN_MAXNUM]; //g_ListedActions: store corrosponding actions to take.
char g_sHelpText[PATTERN_MAXNUM][HELPTEXT_STRMAXLEN+1];
unsigned int g_NumberOfPatterns=0; //g_NumberOfPatterns: how many patterns were loaded from PATTERN file? it's COUNT, not INDEX
static BOOL bInternal = TRUE;  //DETOURS VARIABLE
static HINSTANCE g_hInstance = NULL; //DETOURS VARIABLE

#include "commonfun.cpp"
#include "recordlog.cpp"
#include "intercept-GetMatchResult.cpp"
#include "intercept-checkpoint-CreateFileW.cpp"
#include "intercept-checkpoint-CreateProcessInternalW.cpp"
#include "intercept-checkpoint-RegKey.cpp"
#include "intercept-checkpoint-DllMain.cpp"
#include "intercept-init.cpp"
#include "intercept-unload.cpp"

BOOL WINAPI DllMain(HINSTANCE hinst, DWORD dwReason, LPVOID reserved)
{
    g_hInstance = hinst;
    
    if (dwReason == DLL_PROCESS_ATTACH) 
    {
            
        GetMatchResult_INIT();
        DllMainCheck();
        InitInterception(); 
        bInternal = FALSE;
    }
    else if (dwReason == DLL_PROCESS_DETACH) 
    {
        UnloadInterception();
        bInternal = TRUE;
    }
    return TRUE;
}
