//////////////////////////////////////////////////////////////////////////////
//  File:       intercept-GetMatchResult.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
void GetMatchResult_INIT_RecordInvalidLine(char * sReason, char * sBuffer)
{
    RecordLog(sReason,TRUE);
    RecordLog(sBuffer,TRUE);
}
BOOL WINAPI GetMatchResult_INIT(void)
{
        char sFileNameBuff[FILENAME_STRMAXLEN+1] = "";
	char sBuffer[LISTLINE_STRMAXLEN+1] = "";
        char * sActionList = NULL;
        char * sRegexPattern = NULL;
        char * fgetsResult = NULL;
        DWORD dwListedAction = 0;
        const char * pcre_error;
        int pcre_erroffset = 0;
        g_NumberOfPatterns=0;
        FILE * pfListFile = fopen(GetFullFileNameInInsiderFolder(LIST_FILEID,sFileNameBuff,FILENAME_STRMAXLEN),"r");

        if( pfListFile == NULL )
            return FALSE;
        while( !feof(pfListFile) )
        {
            fgetsResult = fgets(sBuffer , LISTLINE_STRMAXLEN , pfListFile);
            if(fgetsResult == NULL)// which means failure. 
                continue;   
            StripOutEndingNewLineChar(sBuffer);
            if(  (strlen(sBuffer)>LISTLINE_STRMAXLEN)  ||  (strlen(sBuffer)==0)  ||  (sBuffer[0]=='#')  )
                continue; //read next line without processing sBuffer ... because it's too long or empty or a commented line
            sRegexPattern = strstr(sBuffer,"^");
            if(  (sRegexPattern==NULL) || (strlen(sRegexPattern)>=PATTERN_STRMAXLEN-1) )
            {
                GetMatchResult_INIT_RecordInvalidLine("!!!ERROR Regular expression part of the following rule is not found, or it's found to be too long:",sBuffer);
                continue;
            }
	    g_NumberOfPatterns++;
            if( g_NumberOfPatterns>PATTERN_MAXNUM  ) // current one cannot be stored due to storage limit
                return FALSE; //the whole function aborts and returns a value indicating INVALID.
            _strlwr(sRegexPattern); //convert regex string to lower case ... so regex is used not case-sensitive
            g_ListedCompiledRegex[g_NumberOfPatterns-1] = pcre_compile(sRegexPattern, 0, &pcre_error, &pcre_erroffset, NULL);
            //pcre_compile parameters: the pattern , default options , for error message , for error offset , use default character tables  
            if (g_ListedCompiledRegex[g_NumberOfPatterns-1] == NULL) //if failed to compile
            {
                g_NumberOfPatterns--;
                GetMatchResult_INIT_RecordInvalidLine("!!!ERROR Faild to compile regular expression part:",sRegexPattern);
                continue; //process next line
            }
            sActionList = strstr(sBuffer,"$"); //"$" is the splitter located between help text and action list
            if(sActionList==NULL)
            {
                GetMatchResult_INIT_RecordInvalidLine("!!!ERROR Failed to find USD char($) between help text and action list:", sBuffer);
                continue;
            }
            (*sActionList) = 0; //now sBuffer is equal to help text
            sActionList++;
            if(  strlen(sBuffer)<HELPTEXT_STRMAXLEN-1  )
                strncpy(g_sHelpText[g_NumberOfPatterns-1],sBuffer,HELPTEXT_STRMAXLEN-1);
            else//winblox will also work well even if current help text is too long to load - since user can read descriptor in a friendly way.
                strncpy(g_sHelpText[g_NumberOfPatterns-1],"<ERROR: HELP TEXT IS TOO LONG TO DISPLAY>",HELPTEXT_STRMAXLEN-1);
            dwListedAction = 0;
            (*sRegexPattern) = 0; // change the first "^" byte to null
            _strlwr(sActionList); //so action list is used not case-sensitive
            if(strstr(sActionList,GETMATCHRESULT_ACTION_RECORD_STR)!=NULL) //if found in sBuffer
                dwListedAction = dwListedAction + GETMATCHRESULT_ACTION_RECORD_DWORD;
            if(strstr(sActionList,GETMATCHRESULT_ACTION_CONFIRM_STR)!=NULL) //if found in sBuffer
                dwListedAction = dwListedAction + GETMATCHRESULT_ACTION_CONFIRM_DWORD;
            if(strstr(sActionList,GETMATCHRESULT_ACTION_FILTER_STR)!=NULL) //if found in sBuffer
                dwListedAction = dwListedAction + GETMATCHRESULT_ACTION_FILTER_DWORD;
            g_ListedActions[g_NumberOfPatterns-1] = dwListedAction;
        }
        fclose(pfListFile);
        return TRUE;
}
BOOL WINAPI ConfirmDescriptor(char * sDescriptor, char * sHelpText)
{
    if(strlen(sDescriptor)>DESCRIPTOR_STRMAXLEN)
        return FALSE;
    char sDescriptorDuplicate[DESCRIPTOR_STRMAXLEN+1] = "";
    strncpy(sDescriptorDuplicate,sDescriptor,DESCRIPTOR_STRMAXLEN);
    
    char sMsg[CONFIRMMSG_STRMAXLEN+1]="";
    char *AccountName=NULL, *AppName=NULL, *RequestType=NULL, *RequestParam=NULL, *tmp=NULL;
    int nRet  = 0;
    
    tmp = sDescriptorDuplicate;
    AccountName = tmp;
    tmp = strstr(tmp,"@");
    if(tmp==NULL)
        return FALSE;
    (*tmp) = 0;
    tmp++;
    RequestType = tmp;
    tmp=strstr(tmp,":");
    if(tmp==NULL)
        return FALSE;
    (*tmp) = 0;
    tmp++; 
    AppName = tmp;
    tmp=strstr(tmp,"==>");
    if(tmp==NULL)
        return FALSE;
    (*tmp) = 0;
    RequestParam = tmp + 3;
    
    nRet = _snprintf(sMsg,CONFIRMMSG_STRMAXLEN,CONFIRMMSG_FORMATSTR,sHelpText,AppName,AccountName,RequestType,RequestParam);
    if(nRet<0)//a negative value is returned WHEN the number of bytes required to store the data exceeds count
        return FALSE;
    nRet = MessageBoxA( 0,sMsg,"WinBlox Alert",MB_YESNO );
    if( nRet==IDYES ) // Yes button was selected.
        return TRUE;
    return FALSE;
}
BOOL WINAPI GetMatchResult(char * sDescriptor)
{
        _strlwr(sDescriptor);
        unsigned int i = 0;
        int ovector[OVECCOUNT];
        int rc = 0;
        for(i=0;i<g_NumberOfPatterns;i++)//so do not return TRUE without passing ALL tests!
        {
            rc = pcre_exec(
                  g_ListedCompiledRegex[i], // the compiled pattern   
                  NULL,                     // no extra data - we didn't study the pattern   
                  sDescriptor,              // the subject string 
                  (int)strlen(sDescriptor), // the length of the subject   
                  0,                    // start at offset 0 in the subject   
                  0,                    // default options   
                  ovector,              // output vector for substring information   
                  OVECCOUNT);           // number of elements in the output vector 
            if(rc < 0) // match failed.
                continue;
            //now, sDescriptor and current ListedCompiledRegex matches. let's perform corrosponding actions
            if( (g_ListedActions[i]&GETMATCHRESULT_ACTION_RECORD_DWORD)!=0  )
                RecordLog(sDescriptor,FALSE);
            if( (g_ListedActions[i]&GETMATCHRESULT_ACTION_FILTER_DWORD)!=0  )
                return FALSE;
            if( (g_ListedActions[i]&GETMATCHRESULT_ACTION_CONFIRM_DWORD)!=0  )
            if(ConfirmDescriptor(sDescriptor,g_sHelpText[i])==FALSE)
                    return FALSE;
        }
        return TRUE;//approve this operation, after going thru all checks
}
