//////////////////////////////////////////////////////////////////////////////
//  File:       intercept-checkpoint-CreateFileW.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
#define CREATEFILEW_ERRORCODE ERROR_PATH_NOT_FOUND  
#define ACCESSDESCRIPTION_MAXNUM 21 
#define ACCESSDESCRIPTION_STRMAXLEN 21*40
BOOL WINAPI GetAccessType(DWORD dwDesiredAccess, char * sBuffer, unsigned int nSize)
{   
        if( nSize<ACCESSDESCRIPTION_STRMAXLEN+1 )
        //CAUTION: going to Write to sBuffer with "strcat". the size of sBuffer should be big enough
        {
            sBuffer[0] = 0;
            return FALSE;
        }
        DWORD KnownAccessNumber[]={
                        FILE_ADD_FILE,          // count:1,index:0
                        FILE_ADD_SUBDIRECTORY,  // count:2,index:1
                        FILE_ALL_ACCESS,        // count:3,index:2
                        FILE_APPEND_DATA,       // count:4,index:3
                        FILE_CREATE_PIPE_INSTANCE,  // count:5,index:4
                        FILE_DELETE_CHILD,      // count:6,index:5
                        FILE_EXECUTE,           // count:7,index:6
                        FILE_LIST_DIRECTORY,    // count:8,index:7
                        FILE_READ_ATTRIBUTES,   // count:9,index:8
                        FILE_READ_DATA,         // count:10,index:9
                        FILE_READ_EA,           // count:11,index:10
                        FILE_TRAVERSE,          // count:12,index:11
                        FILE_WRITE_ATTRIBUTES,  // count:13,index:12
                        FILE_WRITE_DATA,        // count:14,index:13
                        FILE_WRITE_EA,          // count:15,index:14
                        STANDARD_RIGHTS_READ,   // count:16,index:15
                        STANDARD_RIGHTS_WRITE,  // count:17,index:16
                        SYNCHRONIZE,            // count:18,index:17
                        GENERIC_EXECUTE,        // count:19,index:18
                        GENERIC_READ,           // count:20,index:19
                        GENERIC_WRITE          // count:21,index:20
                    };
        char * KnownAccessType[]={
                        "FILE_ADD_FILEID",      // count:1,index:0
                        "FILE_ADD_SUBDIRECTORY",// count:2,index:1  
                        "FILE_ALL_ACCESS",      // count:3,index:2
                        "FILE_APPEND_DATA",     // count:4,index:3
                        "FILE_CREATE_PIPE_INSTANCE",// count:5,index:4
                        "FILE_DELETE_CHILD",    // count:6,index:5
                        "FILE_EXECUTE",         // count:7,index:6
                        "FILE_LIST_DIRECTORY",  // count:8,index:7
                        "FILE_READ_ATTRIBUTES", // count:9,index:8
                        "FILE_READ_DATA",       // count:10,index:9
                        "FILE_READ_EA",         // count:11,index:10
                        "FILE_TRAVERSE",        // count:12,index:11
                        "FILE_WRITE_ATTRIBUTES",// count:13,index:12
                        "FILE_WRITE_DATA",      // count:14,index:13
                        "FILE_WRITE_EA",        // count:15,index:14
                        "STANDARD_RIGHTS_READ", // count:16,index:15
                        "STANDARD_RIGHTS_WRITE",// count:17,index:16
                        "SYNCHRONIZE",          // count:18,index:17
                        "GENERIC_EXECUTE",      // count:19,index:18
                        "GENERIC_READ",         // count:20,index:19
                        "GENERIC_WRITE"         // count:21,index:20
                    };
        int i=0, nFoundAccess=0;
        sBuffer[0] = 0;
        for(i=0;i<ACCESSDESCRIPTION_MAXNUM;i++)
        if((KnownAccessNumber[i] & dwDesiredAccess)!=0)
        {
            if(nFoundAccess>0)
                strcat(sBuffer,"|");//size of sBuffer is already checked 
            strcat(sBuffer,KnownAccessType[i]);//size of sBuffer is already checked 
            nFoundAccess++;
        }
        if(nFoundAccess==0) 
        {
            sBuffer[0] = 0;
            _snprintf(sBuffer,nSize,"UNKNOWN_ACCESS_CODE:%08x",dwDesiredAccess);//size of sBuffer is already checked 
        }
        return FALSE;
}
BOOL WINAPI PreCreateFileHandle(LPWSTR lpFileName,DWORD dwDesiredAccess)
{
    char sAccessType[ACCESSDESCRIPTION_STRMAXLEN+1] = ""; 
    GetAccessType(dwDesiredAccess,sAccessType,ACCESSDESCRIPTION_STRMAXLEN+1);
    char sFileName[FILENAME_STRMAXLEN+1] = ""; 
    char sFullFileName[FILENAME_STRMAXLEN+1] = "";
    char sDescriptor[DESCRIPTOR_STRMAXLEN+1] = "";
    int nRet = 0;
    nRet = WideCharToMultiByte(CP_ACP, 0, lpFileName, -1, sFileName, FILENAME_STRMAXLEN, NULL, NULL);
    if(nRet == 0) //got some errors, including ERROR_INSUFFICIENT_BUFFER
        return FALSE;
    GetFullFileNameInCurrentFolder(sFileName,sFullFileName,FILENAME_STRMAXLEN+1);//get fullfilename
    if( sFileName[0]==0 )//empty string means failure.
        return FALSE;
    sDescriptor[0] = 0;
    //BUGBUG! fixed potential buffer overflow after a bugtraq post by Oliver Lavery(olavery AT pivx DzeroT com). thanks for pointing out this bug!
    nRet = _snprintf(sDescriptor,DESCRIPTOR_STRMAXLEN,"%s@access_file:%s > %s ==> %s --> %s", GetCurrentUserName(), GetMainModuleFileName(), GetCommandLine(), sAccessType, sFullFileName);
    if(nRet < 0)   //number of bytes required to store the data exceeds limit
        return FALSE;   
    return GetMatchResult(sDescriptor);
}
HANDLE WINAPI My_CreateFileW(
            LPWSTR lpFileName,
            DWORD dwDesiredAccess,
              DWORD dwShareMode,
            LPSECURITY_ATTRIBUTES lpSecurityAttributes,
            DWORD dwCreationDisposition,
            DWORD dwFlagsAndAttributes,
            HANDLE hTemplateFile
            )
{
    if(  PreCreateFileHandle(lpFileName,dwDesiredAccess)==FALSE  )
    {
        SetLastError(CREATEFILEW_ERRORCODE);
        return INVALID_HANDLE_VALUE;
    }
    return Real_CreateFileW( lpFileName,
                    dwDesiredAccess,
                    dwShareMode,
                    lpSecurityAttributes,
                    dwCreationDisposition,
                    dwFlagsAndAttributes,
                    hTemplateFile);
}
