//////////////////////////////////////////////////////////////////////////////
//  File:       intercept-checkpoint-CreateProcessInternalW.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
#define NEWPROCESS_ERRORCODE ERROR_INVALID_PARAMETER
typedef DWORD (WINAPI * PROCTYPE_CreateProcessInternalW) 
        (
                DWORD,
                LPCWSTR,
                LPWSTR,
                DWORD,
                DWORD,
                DWORD,
                DWORD,
                DWORD,
                DWORD,
                DWORD,
                LPPROCESS_INFORMATION,              
                DWORD
            );
PROCTYPE_CreateProcessInternalW Real_CreateProcessInternalW;

BOOL WINAPI PreNewProcess(LPCWSTR lpApplicationName,LPCWSTR lpCommandLine)//return FALSE to cancel NEW-PROCESS operation
{
    char sAppName[FILENAME_STRMAXLEN+1] = "";
    char sCmdline[CMDLINE_STRMAXLEN+1] = "";
    char sDescriptor[DESCRIPTOR_STRMAXLEN+1] = "";
    int nRet = 0;
    //BUGBUG! sometimes EXPLORER.EXE executes programs with lpApplicationName equal to NULL which gonna make WideCharToMultiByte fail.
    if(lpApplicationName==NULL)
        strncpy(sAppName,"NULL",FILENAME_STRMAXLEN);
    else
    {
        nRet = WideCharToMultiByte(CP_ACP, 0, lpApplicationName, -1, sAppName, FILENAME_STRMAXLEN, NULL, NULL);
        if(nRet == 0) //errors, including ERROR_INSUFFICIENT_BUFFER
            return FALSE;
    }
    if(lpCommandLine==NULL)
        strncpy(sCmdline,"NULL",CMDLINE_STRMAXLEN);
    else
    {
        nRet = WideCharToMultiByte(CP_ACP, 0, lpCommandLine, -1, sCmdline, CMDLINE_STRMAXLEN, NULL, NULL);
        if(nRet == 0) //errors, including ERROR_INSUFFICIENT_BUFFER
            return FALSE;
    }
    nRet = _snprintf(sDescriptor,DESCRIPTOR_STRMAXLEN,"%s@execute_program:%s > %s ==> %s --> %s", GetCurrentUserName(), GetMainModuleFileName(), GetCommandLine(), sAppName, sCmdline);
    if( nRet<0 )
        return FALSE;
    return GetMatchResult(sDescriptor);
}
BOOL WINAPI My_CreateProcessInternalW(
    DWORD PARAM_0x01,
    LPCWSTR lpApplicationName,
    LPWSTR lpCommandLine,
    DWORD PARAM_0x04,
    DWORD PARAM_0x05,
    DWORD PARAM_0x06,
    DWORD dwCreationFlag,
    DWORD PARAM_0x08,
    DWORD PARAM_0x09,
    DWORD PARAM_0x0a,
    LPPROCESS_INFORMATION lpProcessInformation,
    DWORD PARAM_0x0c
    )
{
    if(PreNewProcess(lpApplicationName,lpCommandLine)==FALSE)
    {
        SetLastError(NEWPROCESS_ERRORCODE);
        return FALSE;
    }
    PROCESS_INFORMATION pi;
    BOOL bRet = Real_CreateProcessInternalW(
            PARAM_0x01,
            lpApplicationName,
            lpCommandLine,
            PARAM_0x04,
            PARAM_0x05,
            PARAM_0x06,
            (dwCreationFlag|CREATE_SUSPENDED),
            PARAM_0x08,
            PARAM_0x09,
            PARAM_0x0a,
            &pi,
            PARAM_0x0c
            );
    if(bRet)
    {
        char sInsiderDotDllFileName[FILENAME_STRMAXLEN+1] = "";
        GetFullFileNameInInsiderFolder(INSIDER_FILEID, sInsiderDotDllFileName, FILENAME_STRMAXLEN+1);
        InjectLibrary(pi.hProcess,pi.hThread,DetourFindFunction("kernel32.dll","LoadLibraryA"),(PBYTE)sInsiderDotDllFileName,strlen(sInsiderDotDllFileName)+1);
        if((dwCreationFlag&CREATE_SUSPENDED)==0)//BUGBUG! we need to avoid ResumeThread if client has enabled the CREATE_SUSPENDED flag. so debuggers like OllyDbg can work.
            ResumeThread(pi.hThread);
    }
    if(lpProcessInformation!=NULL)
            CopyMemory(lpProcessInformation, &pi, sizeof(pi));
    return bRet;
}
