//////////////////////////////////////////////////////////////////////////////
//  File:       intercept-checkpoint-RegKey.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
#define REGKEY_ERRORCODE ERROR_BADKEY
HKEY g_hKnownRegHkeyArray[] = {HKEY_CLASSES_ROOT,HKEY_CURRENT_CONFIG,HKEY_CURRENT_USER,HKEY_LOCAL_MACHINE,HKEY_USERS};
char * g_sKnownRegPathArray[] = {"HKEY_CLASSES_ROOT","HKEY_CURRENT_CONFIG","HKEY_CURRENT_USER","HKEY_LOCAL_MACHINE","HKEY_USERS"};
DWORD dwKnownRegCount = 5;
BOOL WINAPI PreRegKeyA(HKEY hRegBaseKey, LPCSTR lpSubKey)
{
    char sRegBaseKey[REGKEY_STRMAXLEN+1] = "";
    int nRet = 0;
    DWORD i = 0;
    char sDescriptor[DESCRIPTOR_STRMAXLEN+1] = "";
    _snprintf(sRegBaseKey,REGKEY_STRMAXLEN,"0x%08x",hRegBaseKey);//default value
    for(i=0;i<dwKnownRegCount;i++)//check if it's a known value
    if(g_hKnownRegHkeyArray[i]==hRegBaseKey)
    {
        strncpy(sRegBaseKey,g_sKnownRegPathArray[i],REGKEY_STRMAXLEN);
        break;
    }
    //BUGBUG! lpSubKey can be NULL (a hard bug)
    nRet = _snprintf(sDescriptor,DESCRIPTOR_STRMAXLEN,"%s@open_registry_key:%s > %s ==> %s\\%s --> NULL", GetCurrentUserName(), GetMainModuleFileName(), GetCommandLine(), sRegBaseKey, (lpSubKey==NULL)?"NULL":lpSubKey);
    if( nRet<0 )
        return FALSE;
    return GetMatchResult(sDescriptor);
}
BOOL WINAPI PreRegKeyW(HKEY hRegBaseKey, LPCWSTR lpSubKey)
{
    char sSubKey[REGKEY_STRMAXLEN+1] = "";
    char sRegBaseKey[REGKEY_STRMAXLEN+1] = "";
    int nRet = 0;
    DWORD i = 0;
    char sDescriptor[DESCRIPTOR_STRMAXLEN+1] = "";
    if(lpSubKey==NULL) //BUGBUG! lpSubKey can be NULL (a hard bug)
        strncpy(sSubKey,"NULL",REGKEY_STRMAXLEN);
    else
    {
        nRet = WideCharToMultiByte(CP_ACP, 0, lpSubKey, -1, sSubKey, REGKEY_STRMAXLEN, NULL, NULL);
        if(nRet == 0) //errors, including ERROR_INSUFFICIENT_BUFFER
            return FALSE;
    }
    _snprintf(sRegBaseKey,REGKEY_STRMAXLEN,"0x%08x",hRegBaseKey);//default value
    for(i=0;i<dwKnownRegCount;i++)//check if it's known value
    if(g_hKnownRegHkeyArray[i]==hRegBaseKey)
    {
        strncpy(sRegBaseKey,g_sKnownRegPathArray[i],REGKEY_STRMAXLEN);
        break;
    }
    nRet = _snprintf(sDescriptor,DESCRIPTOR_STRMAXLEN,"%s@open_registry_key:%s > %s ==> %s\\%s --> NULL", GetCurrentUserName(), GetMainModuleFileName(), GetCommandLine(), sRegBaseKey, sSubKey);
    if( nRet<0 )
        return FALSE;
    return GetMatchResult(sDescriptor);
}



LONG WINAPI My_RegCreateKeyExA(
    HKEY hKey,
    LPCSTR lpSubKey,
    DWORD Reserved,
    LPSTR lpClass,
    DWORD dwOptions,
    REGSAM samDesired,
    LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    PHKEY phkResult,
    LPDWORD lpdwDisposition)
{
    if(PreRegKeyA(hKey,lpSubKey)==FALSE)
        return REGKEY_ERRORCODE;
    return Real_RegCreateKeyExA (
                    hKey,
                    lpSubKey,
                    Reserved,
                    lpClass,
                    dwOptions,
                    samDesired,
                    lpSecurityAttributes,
                    phkResult,
                    lpdwDisposition);
}
LONG WINAPI My_RegCreateKeyExW (
    HKEY hKey,
    LPCWSTR lpSubKey,
    DWORD Reserved,
    LPWSTR lpClass,
    DWORD dwOptions,
    REGSAM samDesired,
    LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    PHKEY phkResult,
    LPDWORD lpdwDisposition
    )
{
    if(PreRegKeyW(hKey,lpSubKey)==FALSE)
        return REGKEY_ERRORCODE;
    return Real_RegCreateKeyExW (
            hKey,
            lpSubKey,
            Reserved,
            lpClass,
            dwOptions,
            samDesired,
            lpSecurityAttributes,
            phkResult,
            lpdwDisposition
    );
}
LONG WINAPI My_RegOpenKeyExA (
    HKEY hKey,
    LPCSTR lpSubKey,
    DWORD ulOptions,
    REGSAM samDesired,
    PHKEY phkResult)
{
    if(PreRegKeyA(hKey,lpSubKey)==FALSE)
        return REGKEY_ERRORCODE;
    return Real_RegOpenKeyExA (
            hKey,
            lpSubKey,
            ulOptions,
            samDesired,
            phkResult);
}
LONG WINAPI My_RegOpenKeyExW (
    HKEY hKey,
    LPCWSTR lpSubKey,
    DWORD ulOptions,
    REGSAM samDesired,
    PHKEY phkResult)
{
    if(PreRegKeyW(hKey,lpSubKey)==FALSE)
        return REGKEY_ERRORCODE;
    return Real_RegOpenKeyExW(
            hKey,
            lpSubKey,
            ulOptions,
            samDesired,
            phkResult);
}
