//////////////////////////////////////////////////////////////////////////////
//  File:       recordlog.cpp
//  Module:     INSIDER.DLL
//  Copyright 2005, WinBlox Project http://umbrella.name/upid/winblox
//
BOOL WINAPI RecordLog(LPSTR sDescriptor, BOOL bCreateFileW) 
//this function works even CREATEFILE API is under interception. 
//if it's not under interception yet, set bCreateFileW to TRUE
{
    HANDLE hAppend = NULL;
    DWORD dwPos = 0;
    DWORD dwDataSize = 0;
    DWORD dwBytesWritten = 0;
    char MsgBuff[LOGTEXT_STRMAXLEN+1] = "";
    char sFullFileName[FILENAME_STRMAXLEN+1] = "";
    WCHAR wsFullFileName[FILENAME_STRMAXLEN+1] =L"";
    SYSTEMTIME SystemTime;
    if(strlen(sDescriptor) > DESCRIPTOR_STRMAXLEN)//BUGBUG! this check is added after suggestion from Oliver Lavery(olavery AT pivx DzeroT com)
        return FALSE;
    GetLocalTime(&SystemTime);
    //the following _snprintf is executed after checking the length of sDescriptor. so there is surely enough space.
    _snprintf(  MsgBuff,LOGTEXT_STRMAXLEN,"%4d/%02d/%02d @ %02d:%02d:%02d.%03d # %s\n", SystemTime.wYear, SystemTime.wMonth, SystemTime.wDay, SystemTime.wHour, SystemTime.wMinute, SystemTime.wSecond, SystemTime.wMilliseconds, sDescriptor);
    dwDataSize = strlen(MsgBuff);
    GetFullFileNameInInsiderFolder(LOG_FILEID,sFullFileName,FILENAME_STRMAXLEN);
    int nRet = MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, sFullFileName, -1, wsFullFileName, FILENAME_STRMAXLEN );
    if( nRet==0 )//If the function fails, the return value is zero. 
        return FALSE;
    if(bCreateFileW)
        hAppend = CreateFileW(wsFullFileName, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    else
        hAppend = Real_CreateFileW(wsFullFileName, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hAppend == INVALID_HANDLE_VALUE) 
        return FALSE;
    dwPos = SetFilePointer(hAppend, 0, NULL, FILE_END); 
    LockFile(hAppend, dwPos, 0, dwDataSize, 0); 
    WriteFile(hAppend, MsgBuff, dwDataSize, &dwBytesWritten, NULL); 
    UnlockFile(hAppend, dwPos, 0, dwDataSize, 0); 
    CloseHandle(hAppend);
    return TRUE;
}
